// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of scatter
//
// scatter is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// scatter is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the
//       Free Software Foundation, Inc.
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#ifndef PHOTON_H
#define PHOTON_H

#include <iostream>

#include <bpipexx/bpipexx.h>

namespace Scatter {

    class Photon {

    public:
	Photon( SAOTrace::BPipeX::Simple &bpipe );

	DVector3 position() 		{ return *_position; }

	DVector3  direction() 		{ return *_direction; }
	DVector3* p_direction() 	{ return _direction; }

	DVector3 surface_norm() 	{ return *_surface_norm; }
	double energy() 		{ return *_energy; }

	double  theta() 		{ return *_theta; }
	double* p_theta() 		{ return _theta; }

	double  phi() 			{ return *_phi; }
	double* p_phi() 		{ return _phi; }

	unsigned int id() 		{ return *_id; }
	unsigned int surf_missed() 	{ return *_surf_missed; }

	void dump();

    private:
	DVector3* _position;
        DVector3* _direction;
 	DVector3* _surface_norm;
	double* _energy;
	double* _theta;
	double* _phi;
	unsigned int* _id;
	unsigned int* _surf_missed;

    };

}

#endif // #ifndef PHOTON_H
