. tests/common.sh

#------------------------------------------------------

test_initialize
test_set_hook result test_result_hook_save_output_on_failure
test_set check_exit_status 1

#------------------------------------------------------
# test the basic ray scatter algorithm by sending in a single
# ray and specific specular and out of plane scattering angles

test_begin_subtests

theta=50
phi=34

$TEST_SCATTER                                           \
	       --nrays=1                                \
	       --no-in_plane                            \
	       --no-out_of_plane                        \
	       --alpha  50                              \
	       --energy 1.0                             \
	       --theta $theta                           \
	       --phi   $phi                             \
	       --tag=$(testpfx)                         \
	       --srcdir=$scatter_dir                    \
	       --zpos=0                                 \
	       --mirror_db='${INPUTDIR}/mirror.rdb'     \
	       --scatter_db='${INPUTDIR}/sawtooth.rdb'

test_is $? 0 "explicit angle: generate"


theta_out=$(fits2rdb -c theta $(testpfx).scatter.calc.fits | tail -1 | rad2arcsec )
phi_out=$(fits2rdb -c phi $(testpfx).scatter.calc.fits | tail -1 | rad2arcsec )

ndiff_args="-relerr 1e-8"

test_ndiff_is -a "$ndiff_args" "$theta_out" $theta  "explicit angle: theta"
test_ndiff_is -a "$ndiff_args" "$phi_out"   $phi    "explicit angle: phi"


test_end_subtests

test_summary
test_exit
